// TabPageTwo.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "Eapi.h"
#include "EApi_Seco.h"
#include "TabPage2.h"


// CTabPageTwo dialog

IMPLEMENT_DYNAMIC(CTabPageTwo, CDialog)
CTabPageTwo::CTabPageTwo(CWnd* pParent /*=NULL*/)
	: CDialog(CTabPageTwo::IDD, pParent)
	, m_reset_causes_RST_BUT(FALSE)
	, m_reset_causes_WDT_TIMEOUT(FALSE)
	, m_reset_causes_PWR_BUT(FALSE)
{
}

CTabPageTwo::~CTabPageTwo()
{
}

void CTabPageTwo::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Control(pDX, IDC_TEMPERATURE1, m_Temperature1);
	DDX_Control(pDX, IDC_TEMPERATURE2, m_Temperature2);
	DDX_Control(pDX, IDC_TEMPERATURE3, m_Temperature3);
	DDX_Control(pDX, IDC_FAN_RPS, m_Fan_RPM);
	DDX_Control(pDX, IDC_FAN_RPS2, m_Fan_RPM2);
	DDX_Control(pDX, IDC_VCORE, m_VCore_Voltage);
	DDX_Control(pDX, IDC_2V5, m_2V5_Voltage);
	DDX_Control(pDX, IDC_3V3, m_3V3_Voltage);
	DDX_Control(pDX, IDC_VBAT, m_VBat_Voltage);
	DDX_Control(pDX, IDC_5V, m_5V_Voltage);
	DDX_Control(pDX, IDC_5VSB, m_5VSB_Voltage);
	DDX_Control(pDX, IDC_12V, m_12V_Voltage);
	DDX_Control(pDX, IDC_BACKLIGHT_PERCENT, m_label_backlight);
	DDX_Control(pDX, IDC_SLIDER_BACKLIGHT, m_slider_backlight);
	DDX_Control(pDX, IDC_SWITCH, m_Switch);
	DDX_Check(pDX, IDC_RST_BUT, m_reset_causes_RST_BUT);
	DDX_Check(pDX, IDC_WDT_TIMEOUT, m_reset_causes_WDT_TIMEOUT);
	DDX_Check(pDX, IDC_PWR_BUT, m_reset_causes_PWR_BUT);
}


BEGIN_MESSAGE_MAP(CTabPageTwo, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_WM_HSCROLL()
	ON_BN_CLICKED(IDC_CLR_RST_CAUSE, &CTabPageTwo::OnBnClickedClrRstCause)
END_MESSAGE_MAP()


// CTabPageTwo message handlers

void CTabPageTwo::PrintReturn(unsigned long dwRet)
{
	char msg[1024];

	switch(dwRet)
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_ERROR:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_INVALID_PARAMETER:
			MessageBox(TEXT("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			break;
		case EAPI_STATUS_NOT_FOUND:
			MessageBox(TEXT("EAPI_STATUS_NOT_FOUND"), 0, 0);
			break;
		case EAPI_STATUS_READ_ERROR:
			MessageBox(TEXT("EAPI_STATUS_READ_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_WRITE_ERROR:
			MessageBox(TEXT("EAPI_STATUS_WRITE_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_TIMEOUT:
			MessageBox(TEXT("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
		default:
			wsprintf(msg, TEXT("EAPI_ERROR N: 0x%08X"),dwRet);
			MessageBox(TEXT("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
	}
}


BOOL CTabPageTwo::OnInitDialog()
{
	CDialog::OnInitDialog();

	uint32_t ResetCauses;

	if(EApiGetResetCauses(&ResetCauses) == EAPI_STATUS_SUCCESS)
	{
		if(ResetCauses & RESET_CAUSE_RESET)
			m_reset_causes_RST_BUT = true;
		else
			m_reset_causes_RST_BUT = false;

		if(ResetCauses & RESET_CAUSE_WDT)
			m_reset_causes_WDT_TIMEOUT = true;
		else
			m_reset_causes_WDT_TIMEOUT = false;

		if(ResetCauses & RESET_CAUSE_PWFAIL)
			m_reset_causes_PWR_BUT = true;
		else
			m_reset_causes_PWR_BUT = false;

		UpdateData(false);

		return TRUE;
	}
	else
	{
		GetDlgItem(IDC_WDT_TIMEOUT)->EnableWindow(FALSE);
		GetDlgItem(IDC_RST_BUT)->EnableWindow(FALSE);
		GetDlgItem(IDC_PWR_BUT)->EnableWindow(FALSE);
		GetDlgItem(IDC_CLR_RST_CAUSE)->EnableWindow(FALSE);

		return FALSE;
	}

	return TRUE;

}

void CTabPageTwo::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here

}

void CTabPageTwo::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar)
{
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);

	unsigned long value;
	char msg[1024];

	if(1)
	{
		value = m_slider_backlight.GetPos();

		EApiVgaSetBacklightBrightness(EAPI_ID_BACKLIGHT_1, value);

		m_slider_backlight.SetPos(value);
		wsprintf(msg,_T("%d %%"), value);
		m_label_backlight.SetWindowText(msg);
	}
}
void CTabPageTwo::OnBnClickedClrRstCause()
{
	uint32_t ResetCauses = 0;
	unsigned long dwRet = 0;

	UpdateData(true);

	if(m_reset_causes_RST_BUT)
		ResetCauses += RESET_CAUSE_RESET;
	if(m_reset_causes_WDT_TIMEOUT)
		ResetCauses += RESET_CAUSE_WDT;
	if(m_reset_causes_PWR_BUT)
		ResetCauses += RESET_CAUSE_PWFAIL;

	dwRet = EApiClearResetCauses(ResetCauses);

	PrintReturn(dwRet);

	OnInitDialog();
}