// TabPageTwo.cpp : implementation file
//

#include "stdafx.h"
#include "resource.h"
#include "EAPI_WINDlg.h"
#include "Eapi.h"
#include "EApi_Seco.h"
#include "TabPage4.h"
#include "TabPage5.h"


// CTabPageFive dialog

IMPLEMENT_DYNAMIC(CTabPageFive, CDialog)
CTabPageFive::CTabPageFive(CWnd* pParent /*=NULL*/)
	: CDialog(CTabPageFive::IDD, pParent)
	, m_Storage_num_byte_to_read(0)
	, m_NVS_Data(_T(""))
	, m_NVS_Address(_T(""))
{
}

CTabPageFive::~CTabPageFive()
{
}

void CTabPageFive::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);	
	DDX_Text(pDX, IDC_NVS_NUM_BYTES, m_Storage_num_byte_to_read);
	DDX_Text(pDX, IDC_NVS_ADDRESS, m_NVS_Address);
	DDX_Text(pDX, IDC_NVS_DATA, m_NVS_Data);
}


BEGIN_MESSAGE_MAP(CTabPageFive, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDC_NVS_READ, OnBnClicked_NVS_Write)
	ON_BN_CLICKED(IDC_NVS_WRITE, OnBnClicked_NVS_Read)
END_MESSAGE_MAP()


// CTabPageFive message handlers

void CTabPageFive::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here

}

void CTabPageFive::PrintReturn(unsigned long dwRet)
{
	char msg[1024];

	switch(dwRet)
	{
		case EAPI_STATUS_SUCCESS:
			break;
		case EAPI_STATUS_ERROR:
			MessageBox(TEXT("EAPI_STATUS_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_INVALID_PARAMETER:
			MessageBox(TEXT("EAPI_STATUS_INVALID_PARAMETER"), 0, 0);
			break;
		case EAPI_STATUS_NOT_FOUND:
			MessageBox(TEXT("EAPI_STATUS_NOT_FOUND"), 0, 0);
			break;
		case EAPI_STATUS_READ_ERROR:
			MessageBox(TEXT("EAPI_STATUS_READ_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_WRITE_ERROR:
			MessageBox(TEXT("EAPI_STATUS_WRITE_ERROR"), 0, 0);
			break;
		case EAPI_STATUS_UNSUPPORTED:
			MessageBox(TEXT("EAPI_STATUS_UNSUPPORTED"), 0, 0);
			break;
		case EAPI_STATUS_TIMEOUT:
			MessageBox(TEXT("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
		default:
			wsprintf(msg, TEXT("EAPI_ERROR N: 0x%08X"),dwRet);
			MessageBox(TEXT("EAPI_STATUS_TIMEOUT"), 0, 0);
			break;
	}
}

void CTabPageFive::OnBnClicked_NVS_Write()
{
	unsigned long dwID = 0;
	unsigned long Dev_Add_Byte;
	unsigned char bAddr = 0;
	unsigned long LenBufferFind = 0;
	unsigned long dwLen = 0;
	unsigned long dwRet = 0;
	EApiStatus_t Size = 0;
	CString SingleByte;
	uint32_t  BlockLength;

	unsigned char DataBuffer[LEN_MAX_BYTE_BUFFER];
	
	memset(DataBuffer, 0, LEN_MAX_BYTE_BUFFER);

	UpdateData(true);

	if(!HexDWordStringToUnsignedLong(m_NVS_Address, &Dev_Add_Byte))
	{
		MessageBox(TEXT("Device Address Field Error"), 0, 0);
		return;
	}

	if(!HexStringToUnsignedChar(m_NVS_Data, DataBuffer, &LenBufferFind))
	{
		MessageBox(TEXT("Data Field Error"), 0, 0);
		return;
	}

	dwRet = EApiStorageCap(EAPI_ID_STORAGE_STD, &Size, &BlockLength);

	PrintReturn(dwRet);

	if(dwRet != EAPI_STATUS_SUCCESS)
		return;

	if(Dev_Add_Byte + LenBufferFind > Size)
	{
		MessageBox(TEXT("Too much byte to write"), 0, 0);
		return;
	}

	dwRet = EApiStorageAreaWrite(EAPI_ID_STORAGE_STD, Dev_Add_Byte, DataBuffer, LenBufferFind);

	PrintReturn(dwRet);
}

void CTabPageFive::OnBnClicked_NVS_Read()
{
	unsigned long dwID = 0;
	unsigned long Dev_Add_Byte;
	unsigned char bAddr = 0;
	unsigned long LenBufferFind = 0;
	unsigned char bRead[1024];
	unsigned long dwRet = 0;
	EApiStatus_t Size = 0;
	CString MultipleByte;
	uint32_t  BlockLength;

	UpdateData(true);

	if(!HexDWordStringToUnsignedLong(m_NVS_Address, &Dev_Add_Byte))
	{
		MessageBox(TEXT("Device Address Error"), 0, 0);
		return;
	}

	dwRet = EApiStorageCap(EAPI_ID_STORAGE_STD, &Size, &BlockLength);

	PrintReturn(dwRet);

	if(dwRet != EAPI_STATUS_SUCCESS)
		return;

	if(Dev_Add_Byte + m_Storage_num_byte_to_read > Size)
	{
		MessageBox(TEXT("Too much byte to read"), 0, 0);
		return;
	}

	dwRet = EApiStorageAreaRead(EAPI_ID_STORAGE_STD, Dev_Add_Byte, bRead, 1024,m_Storage_num_byte_to_read);

	PrintReturn(dwRet);

	if(dwRet != EAPI_STATUS_SUCCESS)
		return;
	
	m_NVS_Data = _T("");
	for(int q = 0; q <  m_Storage_num_byte_to_read; q++)
	{
		MultipleByte.Format(_T("%02X "),bRead[q]);
		m_NVS_Data += MultipleByte;
	}

	UpdateData(false);
}

